# 56. رفع الصور

تحميل صورة عبر S3 يحتوي على خطوتين:

1. **اطلب رابط موقّع مسبقًا للقيام بالتحميل المباشر لاحقًا.**&#x20;

كمُدخل:&#x20;

* fileExtention - jpeg أو jpg أو png،&#x20;
* farmUuid - معرف UUID للمزرعة،
* fieldUuid - معرف UUID للحقل،
* noteUuid - معرف UUID للملاحظة للحصول على الرابط المباشر للصورة المحمّلة،
* commentUuid - معرف UUID للتعليق للحصول على الرابط المباشر للصورة المحمّلة (اختياري).&#x20;

كمُخرج:

* uuid - الـ UUID المتوقع بعد التحميل والمعالجة،
* farmUuid - نفس القيمة كما في المدخلات،
* fieldUuid - نفس القيمة كما في المدخلات،
* noteUuid - نفس القيمة كما في المدخلات،
* commentUuid - نفس القيمة كما في المدخلات (إن وُجد)،
* s3Url - عنوان URL المستخدم لرفع الصورة،
* s3Fields - السمات التي يجب تمريرها في نموذج رفع الصورة.

تفاصيل كيفية استخدام s3Url و s3Fields موضحة في الخطوة الثانية.&#x20;

السمات صالحة لمدة 60 دقيقة فقط لرفع الصورة.

{% code overflow="wrap" lineNumbers="true" %}

```graphql
mutation generatePresignedPostPhotoData {
  generatePresignedPostPhotoData(input:{
    farmUuid: "89196056-61e5-4bce-b676-d488d611a829" 
    fieldUuid: "586a2ef2-03e4-4715-846c-07a2f0cb3016"
    noteUuid: "4a94da1c-f655-4f17-961a-4b0323e5129c"
    fileExtention: jpeg
    
  } ) {
    uuid
    noteUuid
    معرف_الحقل
    معرف_المزرعة
    رابط_s3
    حقول_s3
  }
}
```

{% endcode %}

2. **أرسل صورة محلية إلى s3Url مع سمات النموذج المحددة مسبقًا من s3Fields.**

{% code overflow="wrap" lineNumbers="true" %}

```bash
curl --location --request POST '<s3Url>' \
--form 'key="<value_in_s3Fields>"' \
--form 'AWSAccessKeyId="<value_in_s3Fields>"' \
--form 'x-amz-security-token="<value_in_s3Fields>"' \
--form 'policy="<value_in_s3Fields>"' \
--form 'signature="<value_in_s3Fields>"' \
--form 'file=@"<local_file_path>"'
```

{% endcode %}

سيتم تسليم إشعارات المعالجة عبر آلية الاشتراك الموضحة في GraphQL -> Samples -> [1. الاشتراك: الحصول على الأحداث](/geopard-tutorials/ar/mstndat-wajhh-brmjh-alttbyqat/nzrh-aamh-ala-tlbat-wajhh-brmjh-ttbyqat-geopard/1.-alashtrak-alhswl-ala-alahdath.md).

{% hint style="info" %}
استخدم ‘Accept-Encoding’:’gzip, deflate, br’.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.geopard.tech/geopard-tutorials/ar/mstndat-wajhh-brmjh-alttbyqat/nzrh-aamh-ala-tlbat-wajhh-brmjh-ttbyqat-geopard/56.-rfa-alswr.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
